//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;
	using System.IO;  //must add for read/write
	using System.Text;//must add
 
    
    public partial class LogToCSV
    {
		private static Timer m_timer;
		public string date;
		public string tag1;
		public string tag2;
		public string tag3;
		public string tag1Desc;
		public string tag2Desc;
		public string tag3Desc;
		public string totalString;
		public string dt;
		public string path;
							
		//first time setup, on panel start.  For starting at new day, call the StartNewDay().
		public void Inactivity_Created(System.Object sender, System.EventArgs e)
		{
			dt = string.Format("text-{0:yyy-MM-dd_hh-mm-ss-tt}.csv", DateTime.Now);
			//may want to change from USB to ProjectFiles folder.  USB is accessible via FTP in 2.16 (2.10 SP 3)
			path = "\\Hard Disk\\" + dt;
			// Set up timer
			m_timer = new Timer();
			m_timer.Interval = 1000;  //fire off timer every 1 second
			m_timer.Tick += TimerTick;
			m_timer.Enabled = true;				
		}
		
		private void TimerTick(System.Object sender, System.EventArgs e)
		{
			try
			{
				//check if a flash drive has been inserted
				if(Directory.Exists("\\Hard Disk"))
				{
					//if file already exists, open the stream and append data to it
					if(File.Exists(path))
					{
						Globals.Tags.TimerTicks.Value +=1;
						date = Globals.Tags.SystemTagDateTime.Value.ToString();
						tag1 = Globals.Tags.Tag1.Value.ToString();
						tag2 = Globals.Tags.Tag2.Value.ToString();
						tag3 = Globals.Tags.Tag3.Value.ToString();
						totalString = date + "," + tag1 + "," + tag2 + "," + tag3 + "\n";		
						Globals.Tags.ConcatString.Value = totalString;
				
				
						FileStream fs = new FileStream(path, FileMode.Append, FileAccess.Write, FileShare.Write);
						fs.Close();
						StreamWriter sw = new StreamWriter(path, true, Encoding.ASCII);
						string NextLine = totalString;
						sw.Write(NextLine);
						sw.Close();
					}
						//if file doesn't exist, create the file with the column headers
					else
					{
						FileStream fs = new FileStream(path, FileMode.Append, FileAccess.Write, FileShare.Write);
						fs.Close();
						StreamWriter sw = new StreamWriter(path, true, Encoding.ASCII);
						string NextLine = "TimeStamp, Tag1 Value, Tag2 Value, Tag3 Value\n";
						sw.Write(NextLine);
						sw.Close();
					}
				
			
				}
				else 
					//No USB stick is present, show error window
					Globals.ErrorScreen.Show();
			}
			catch
			{
				MessageBox.Show("System Fault:  Most likely USB ejected while writing");
			}
		}
		public void StopLogging()
		{
			m_timer.Tick -= TimerTick;
			m_timer.Enabled = false;
		}
		
		public void StartNewDay()
		{
			dt = string.Format("text-{0:yyy-MM-dd_hh-mm-ss-tt}.csv", DateTime.Now);
			//may want to change from USB to ProjectFiles folder.  USB is accessible via FTP in 2.16 (2.10 SP 3)
			path = "\\Hard Disk\\" + dt;
			// Set up timer
			m_timer = new Timer();
			m_timer.Interval = 1000;  //fire off timer every 1 second
			m_timer.Tick += TimerTick;
			m_timer.Enabled = true;		
		}

		
		
    }
}
